<template>
  <v-container>
    <v-layout justify-center>
      <v-flex xs12 md10>
        <v-card>
          <v-layout justify-center>
            <h1>電卓</h1>
          </v-layout>
          <v-layout row wrap>
            <v-flex xs7 offset-xs1>
              <v-text-field disabled v-model="previewValue"></v-text-field>
            </v-flex>
            <v-flex xs3 offset-xs1>
              <v-btn flat fab color="green">c</v-btn>
            </v-flex>
          </v-layout>
          <v-layout row wrap v-for="btn in btns" :key="btn[0]">
            <v-flex xs3 v-for="value in btn" :key="value">
              <v-btn flat fab color="green" @click="pushedBtn(value)">{{ value }}</v-btn>
            </v-flex>
          </v-layout>
        </v-card>
      </v-flex>
    </v-layout>
  </v-container>
</template>

<script>
export default {
  data() {
    return {
      previewValue: "0", //表示する値
      operand1: 0, //演算子の前の値
      operand2: 0, //演算子の後ろの値
      operator: "+", //演算子
      isNewNumber: true, //次の入力が新しい数値か、継続か
      prevKey: null, //一つ前の入力キー
      cBtn: "C", //C or AC
      btns: [
        //キー一覧（C以外）
        [7, 8, 9, "/"],
        [4, 5, 6, "*"],
        [1, 2, 3, "-"],
        [0, ".", "=", "+"]
      ]
    };
  },
  methods: {
    /**
     * キー入力時の処理
     * @param {*} value 入力されたキー
     */
    pushedBtn: function(value) {
      //入力キーの判定
      const number = /^[0-9]$/;
      const dot = /^\.$/;
      const operator = /^[\+\-\*\/]$/;
      const equal = /^=$/;
      const clear = /^C$/;
      //キーのタイプ別処理
      if (number.test(value)) {
        this.pushedNumber(value);
      } else if (dot.test(value)) {
        this.pushedDot();
      } else if (operator.test(value)) {
        this.pushedOperator(value);
      } else if (equal.test(value)) {
        this.pushedEqual();
      } else if (clear.test(value)) {
        this.pushedClear();
      } else {
        window.alert("予期しない入力がありました");
      }
      this.prevKey = value;
    },
    /**
     * 数字キーが入力された時の処理
     * @param {*} value 入力された数字
     */
    pushedNumber: function(value) {
      //未入力(0)の時は上書き、それ以外は文字列結合させる
      if (this.isNewNumber) {
        this.previewValue = value.toString();
        this.isNewNumber = false;
      } else {
        this.previewValue += value.toString();
      }
    },
    /**
     * 小数点を入力時の処理
     */
    pushedDot: function() {
      //小数点が存在しない場合のみ入力
      if (this.previewValue.indexOf(".") == -1) {
        this.previewValue += ".";
      }
    },
    /**
     * 演算子入力時の処理
     * @param {*} value 入力された演算子
     */
    pushedOperator: function(value) {
      const reg = /^[\+\-\*\/]$/;
      if (reg.test(this.prevKey)) {
        this.operator = value;
        return;
      }
      //文字列として入力された数値を確定し、数値に変換する
      this.operand2 = Number(this.previewValue);
      //四則演算の実行
      this.calc();
      //次の入力のために初期化
      this.isNewNumber = true;
      this.operand2 = "";
      this.operator = value;
      this.previewValue = this.operand1;
    },
    /**
     * イコールが入力時の処理
     */
    pushedEqual: function() {
      if (this.mode) {
        //eval-mode実装用
        const reg = /^[0-9\.\+\-\*\/\(\)]+$/;
        if (reg.test(this.evalValue)) {
          let result = eval(this.evalValue);
          if (result != undefined) {
            this.evalValue = result;
          } else {
            this.evalValue = "不正な式";
          }
        } else {
          this.evalValue = "不正な式";
        }
      } else {
        if (this.prevKey == "=") {
          return;
        }
        this.operand2 = Number(this.previewValue);
        this.calc();
        this.isNewNumber = true;
        this.previewValue = this.operand1;
        this.cBtn = "AC";
      }
    },
    /**
     * Cボタンが入力時の処理
     */
    pushedClear: function() {
      if (this.cBtn == "C") {
        this.previewValue = "0";
        this.isNewNumber = true;
        this.cBtn = "AC";
      } else if (this.cBtn == "AC") {
        this.reset();
      }
    },
    /**
     * 状態の初期化
     */
    reset: function() {
      this.previewValue = "0";
      this.operand1 = 0;
      this.operand2 = 0;
      this.operator = "+";
      this.isNewNumber = true;
      this.prevKey = null;
      this.cBtn = "C";
    },
    /**
     * 四則演算
     */
    calc: function() {
      switch (this.operator) {
        case "+":
          this.operand1 += this.operand2;
          break;
        case "-":
          this.operand1 -= this.operand2;
          break;
        case "*":
          this.operand1 *= this.operand2;
          break;
        case "/":
          if (this.operand2 == 0) {
            window.alert("0で除算はできません");
            return;
          } else {
            this.operand1 /= this.operand2;
          }
          break;
      }
    }
  }
};
</script>